#!/bin/bash
#
# Installs the udev rules and permissions
#

#
# Check that we are root
#
if [ "$(id -u)" != "0" ]; then
   echo "install-udev should be run as root" 1>&2
   exit 0
fi

rc=0

do_install()
{
	cp 90-alibava.rules /etc/udev/rules.d
}

do_uninstall()
{
	rm -f /etc/udev/rules.d/90-alibava.rules
}

case $1 in
	install)
		do_install
		;;
	uninstall)
		do_uninstall	
		;;
esac

exit 0
#