/*
 * LaserRun.cc
 *
 *  Created on: May 12, 2010
 *      Author: lacasta
 */

#include <ConfigFactory.h>
#include "LaserRun.h"
#include "DAQmanager.h"
#include "Analysis.h"
#include "DAQConfig.h"
#include "LaserConfig.h"
#include "utils.h"

LaserRun::LaserRun(DAQmanager *b)
    : DataRun(b)
{

}

LaserRun::~LaserRun()
{
}
void LaserRun::start_of_run()
{
    DataRun::start_of_run();
    ConfigFactory *cfg = ConfigFactory::instance();
    Analysis *ana = dynamic_cast<Analysis *>(cfg->get("analysis"));

    ana->update_pedestals(false);
}

int LaserRun::loop(std::ostream &oheader)
{
    Alibava *alibava = daqm->get_board();
    ALIBAVA_TRACE_CLASS(alibava, "");
    ConfigFactory *cfg = ConfigFactory::instance();
    LaserConfig *lc = dynamic_cast<LaserConfig *>(cfg->get("laser"));

    get_daq_manager()->get_board()->set_laser_delay(lc->delay());
    return DataRun::loop(oheader);
}

int LaserRun::acquire(unsigned int val)
{
    Alibava *alibava = daqm->get_board();
    ALIBAVA_TRACE_CLASS(alibava, "");
    ConfigFactory *cfg = ConfigFactory::instance();
    DAQConfig *daq = dynamic_cast<DAQConfig *>(cfg->get("daq"));
    return get_daq_manager()->get_board()->laser_acq(daq->sample_size());
}

int LaserRun::read_data()
{
    Alibava *alibava = daqm->get_board();
    ALIBAVA_TRACE_CLASS(alibava, "");
    return get_daq_manager()->get_board()->laser_reading(set_value(), value());
}
