/*
 * debug_usb.cc
 *
 *  Created on: Nov 3, 2009
 *      Author: lacasta
 */
#include <termios.h>
#include <unistd.h>
#include "Alibava.h"
#include "USBserial.h"
#include "utils.h"

int main(int argc, char **argv)
{
    USBserial port;
    Alibava board(port);

    if ( board.open("/dev/alibava0") )
    {
        err_msg(_("Cannot open file"));
    }

    char gc;
    int i,sz = port.wait_for_data(0.00001);
    write_msg(_("Data available: %d"),sz);

    for (i=0;i<sz;i++)
    {
        port.read(&gc, sizeof(char));
        write_msg("...%d\n",i);
    }
    sz = port.wait_for_data(1.e-6);
    write_msg(_("Data available: %d"), sz);

    tcflush(port.fildes(), TCIOFLUSH);

    write_msg(_("Reseting the boards"));

    int iok = board.send_control(Alibava::Reset);
     if (iok < 0)
     {
         err_msg(_("Failed sending Reset."));
     }
     else
     {
         // Check we are in Waiting
         unsigned char reg;
         iok = board.get_state(reg, Alibava::Waiting);
         if (iok<0)
         {
             err_msg(_("State machine did not end up in Waiting mode after reset"));
         }
     }
     //return NoProblem;
     //board.reset(true);
    write_msg(_("...done\n"));
    board.close();
}
