#!/usr/bin/env python
""" This is an example of an asynchronous run
"""
import sys
import time
import socket
from alibavaSOAP import daqParam, Status, Alibava
import alibavaSOAP
import SOAPpy


def main(host="localhost", port=10000):
    server = Alibava(host, port)
    
    #
    # Stop the run if alibava is running
    #
    S = Status( server.getStatus() )
    if S.state:
        server.stopRun()

    # Reset the system
    server.Reset()
    
    
    # Start a very long run asynchronously
    server.startSourceRun(1000000, async=True)
    
    # Monitor the status during 5 seconds.
    t0 = time.time()
    while (time.time() - t0 < 5.0):
        time.sleep(0.1)
        S = Status( server.getStatus() )
        if not S.state:
            break
        
        print '\r', S,
        sys.stdout.flush()

    # Stop the run
    server.stopRun()
    
    # Wait until it is really stopped
    while True:
        time.sleep(0.1)
        S = Status( server.getStatus() )
        if not S.state:
            break
        
    # Get the data
    R = server.getRunData()
    for hst in R:
        print hst
    
if __name__ == "__main__":
    host = 'localhost'
    port =  10000
    
    
    try:
        inps = sys.argv[1]
        indx = inps.find(':')
        data = inps.split(':')
        nitem = len(data)
        if nitem == 2:
            if len(data[0]):
                host = data[0]
                
            if len(data[1]):
                try:
                    port = int(data[1])
                except ValueError:
                    print "Invalid port number", data[1]
                
        elif nitem == 1:
            if (len(data[0])):
                host = data[0]
                
    except IndexError:
        pass
        
    try:
        main(host, port)
    except socket.error as e:
        print "Could not connect", e
        print "Check that alibava-gui is running"